SystemOrganization addCategory: #'DBZ tp'!

Error subclass: #ErrorSemilla
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DBZ tp'!

Object subclass: #Bueno
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DBZ tp'!

!Bueno methodsFor: 'as yet unclassified' stamp: '123 10/22/2013 15:36'!
cedeSemilla: unGuerrero A: otroGuerrero 
 ^ unGuerrero coleccionSemillasHermitanio size > 0
  & (unGuerrero aliados includes: otroGuerrero)! !

Object subclass: #Guerrero
	instanceVariableNames: 'energia puntosVida nivelPelea cantidadSemillasHermitanio coleccionSemillasHermitanio coleccionSemillas aliados bandoContrario puntosVidaPerdidos puntosAtaqueRecibidos puntosAtaquesRecibidos llevaPuesto recibeAtaque unTraje poderesConocidos cantidadAtaquesRecibidos ataquesRecibidos ataque unAtaque'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DBZ tp'!

Guerrero class
	instanceVariableNames: 'coleccionSemillasHermitanio puntosAtaqueRecibidos ataquesRecibidos unosPuntos unPoder'!

Guerrero class
	instanceVariableNames: 'coleccionSemillasHermitanio puntosAtaqueRecibidos ataquesRecibidos unosPuntos unPoder'!

!Guerrero methodsFor: 'as yet unclassified' stamp: ''!
agregarSemillaColeccion: unaSemilla 
	coleccionSemillasHermitanio add: unaSemilla! !

!Guerrero methodsFor: 'as yet unclassified' stamp: ''!
aliados
	^ aliados! !

!Guerrero methodsFor: 'as yet unclassified' stamp: ''!
aliados: unaBag 
	aliados := unaBag! !

!Guerrero methodsFor: 'as yet unclassified' stamp: ''!
aliarCon: unGuerrero 
	(self puedeAliarse: unGuerrero)
			& (unGuerrero puedeAliarse: self)
		ifTrue: [aliados add: unGuerrero.
			unGuerrero aliados add: self].
	^ [aliados
		detect: [:guerrero | guerrero = unGuerrero]]
		ifError: [:exepcion | 'no puede aliarse baby']! !

!Guerrero methodsFor: 'as yet unclassified' stamp: ''!
aprende: unPoder 
	poderesConocidos add: unPoder! !

!Guerrero methodsFor: 'as yet unclassified' stamp: ''!
ataquesRecibidos
	^ ataquesRecibidos! !

!Guerrero methodsFor: 'as yet unclassified' stamp: ''!
ataquesRecibidos: unaBag 
	ataquesRecibidos := unaBag! !

!Guerrero methodsFor: 'as yet unclassified' stamp: ''!
bandoContrario
	^ bandoContrario! !

!Guerrero methodsFor: 'as yet unclassified' stamp: ''!
bandoContrario: unaBag 
	bandoContrario := unaBag! !

!Guerrero methodsFor: 'as yet unclassified' stamp: '123 10/10/2013 00:48'!
calculoAtaquesRecibidos
	^ ataquesRecibidos size // 3 ! !

!Guerrero methodsFor: 'as yet unclassified' stamp: ''!
cantidadAtaquesRecibidos: unaCant 
	cantidadAtaquesRecibidos := unaCant! !

!Guerrero methodsFor: 'as yet unclassified' stamp: ''!
cantidadSemillasHermitanio
	^ coleccionSemillasHermitanio size ! !

!Guerrero methodsFor: 'as yet unclassified' stamp: '123 10/10/2013 01:33'!
coleccionSemillasHermitanio
^ coleccionSemillasHermitanio! !

!Guerrero methodsFor: 'as yet unclassified' stamp: ''!
coleccionSemillasHermitanio: unaBag 
	coleccionSemillasHermitanio := unaBag! !

!Guerrero methodsFor: 'as yet unclassified' stamp: '123 10/22/2013 12:37'!
come: semillaHermitanio 
	(self puedeComer: semillaHermitanio) ifTrue: [ 
	self puntosVida: 1000.
	energia:= self nivelPelea * 5 // 100 + self puntosExtra + self energia.
	coleccionSemillasHermitanio remove: semillaHermitanio.]
	ifFalse: [ ErrorSemilla new signal ]! !

!Guerrero methodsFor: 'accessing' stamp: ''!
energia
	^ energia! !

!Guerrero methodsFor: 'as yet unclassified' stamp: ''!
energia: unaCantidad 
	energia := unaCantidad! !

!Guerrero methodsFor: 'as yet unclassified' stamp: ''!
estaMoribundo
	^ self puntosVida <= 50 ! !

!Guerrero methodsFor: 'as yet unclassified' stamp: ''!
hacerUnAtaqueDe: unosPuntos A: unGuerrero 
	unGuerrero recibeAtaque: unosPuntos.
	^ unGuerrero recibeAtaque! !

!Guerrero methodsFor: 'as yet unclassified' stamp: ''!
llevaPuesto
	^ llevaPuesto! !

!Guerrero methodsFor: 'as yet unclassified' stamp: ''!
llevaPuesto: unTraje 
	llevaPuesto := unTraje! !

!Guerrero methodsFor: 'accessing' stamp: ''!
nivelPelea
	^ nivelPelea! !

!Guerrero methodsFor: 'as yet unclassified' stamp: ''!
nivelPelea: unNivel 
	nivelPelea := unNivel! !

!Guerrero methodsFor: 'as yet unclassified' stamp: '123 10/22/2013 15:37'!
pedir: unaSemilla A: unGuerrero 
 self cantidadSemillasHermitanio = 0
   & (unGuerrero bando cedeSemilla: unGuerrero A: self)
  ifTrue: [unGuerrero coleccionSemillasHermitanio remove: unaSemilla.
   self coleccionSemillasHermitanio add: unaSemilla]
  ifFalse: [Error new signal]! !

!Guerrero methodsFor: 'as yet unclassified' stamp: ''!
poderesConocidos: unaBag 
	poderesConocidos := unaBag! !

!Guerrero methodsFor: 'as yet unclassified' stamp: ''!
puedeAtacarA: unGuerrero 
	^ (self aliados includes: unGuerrero) not ! !

!Guerrero methodsFor: 'as yet unclassified' stamp: '123 10/10/2013 01:59'!
puedeComer: unaSemilla 
	^ (coleccionSemillasHermitanio anySatisfy: [:semilla | semilla = unaSemilla ]) & (self energia < 200).
! !

!Guerrero methodsFor: 'as yet unclassified' stamp: ''!
puedeHacerPoder: unPoder 
	^ poderesConocidos anySatisfy: [:poder | poder = unPoder]
			& unPoder puedeHacerlo: self! !

!Guerrero methodsFor: 'accessing' stamp: ''!
puntosVida
	^ puntosVida + self vidaPerdida ! !

!Guerrero methodsFor: 'as yet unclassified' stamp: ''!
puntosVida: unaCantidad 
	puntosVida := unaCantidad! !

!Guerrero methodsFor: 'as yet unclassified' stamp: ''!
recibeAtaque
	ataquesRecibidos add: unAtaque.
	^ recibeAtaque! !

!Guerrero methodsFor: 'as yet unclassified' stamp: ''!
recibeAtaque: unosPuntos 
	recibeAtaque := unosPuntos! !

!Guerrero methodsFor: 'as yet unclassified' stamp: ''!
seMurio
	^ self puntosVida = 0! !

!Guerrero methodsFor: 'as yet unclassified' stamp: ''!
tieneEnergiaPara: unPoder 
	self energia > unPoder energiaNecesaria! !

!Guerrero methodsFor: 'as yet unclassified' stamp: ''!
vidaPerdida
	^ (llevaPuesto efecto: self)
		- self resistencia ! !

Guerrero subclass: #Monstruo
	instanceVariableNames: 'otroGuerrero puedeAliarse puntosPelea aliados'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DBZ tp'!

!Monstruo methodsFor: 'as yet unclassified' stamp: '123 10/22/2013 15:27'!
bando
	^ (Malo new)! !

!Monstruo methodsFor: 'as yet unclassified' stamp: ''!
puedeAliarse: unGuerrero 
	^ unGuerrero ~= self! !

!Monstruo methodsFor: 'as yet unclassified' stamp: '123 10/22/2013 13:00'!
puntosExtra
^0! !

!Monstruo methodsFor: 'as yet unclassified' stamp: ''!
resistencia
	^ 20 ! !

Guerrero subclass: #Saiyajin
	instanceVariableNames: 'aliados bandoContrario puntosPelea oponentes bando'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DBZ tp'!

Saiyajin class
	instanceVariableNames: 'unGuerrero aliados'!

Saiyajin class
	instanceVariableNames: 'unGuerrero aliados'!

!Saiyajin methodsFor: 'as yet unclassified' stamp: ''!
bando
	^ bando! !

!Saiyajin methodsFor: 'as yet unclassified' stamp: ''!
bando: unBando 
	bando := unBando! !

!Saiyajin methodsFor: 'as yet unclassified' stamp: '123 10/22/2013 12:51'!
puedeAliarse: guerrero 
	^ (guerrero aliados
		sum: [:unAliado | unAliado nivelPelea])
		> (self nivelPelea) & (guerrero ~= self)! !

!Saiyajin methodsFor: 'as yet unclassified' stamp: ''!
puntosExtra
	^ 100 * aliados size! !

!Saiyajin methodsFor: 'as yet unclassified' stamp: ''!
resistencia
	^ self recibeAtaque * 0.01 + self energia! !

Guerrero subclass: #Terricola
	instanceVariableNames: 'otroGuerrero puedeAliarse s aliados'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DBZ tp'!

Terricola class
	instanceVariableNames: 'unGuerrero aliados'!

Terricola class
	instanceVariableNames: 'unGuerrero aliados'!

!Terricola methodsFor: 'as yet unclassified' stamp: '123 10/22/2013 13:30'!
bando
	^ Bueno new! !

!Terricola methodsFor: 'as yet unclassified' stamp: ''!
puedeAliarse: unGuerrero 
	^ unGuerrero bando = Bueno & (unGuerrero ~= self)! !

!Terricola methodsFor: 'as yet unclassified' stamp: ''!
puntosExtra
	^ self energia: self energia + 200! !

!Terricola methodsFor: 'as yet unclassified' stamp: ''!
resistencia
	^ self puntosAtaqueRecibidos - self traje resistencia * 0.05 ! !

Object subclass: #Malo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DBZ tp'!

!Malo methodsFor: 'as yet unclassified' stamp: '123 10/22/2013 15:36'!
cedeSemilla: unGuerrero A: otroGuerrero 
 ^ unGuerrero coleccionSemillasHermitanio size > 1
  & (unGuerrero aliados includes: otroGuerrero)! !

Object subclass: #PoderColectivos
	instanceVariableNames: 'minimoAliadosVivos energiaColectivaMinima'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DBZ tp'!

!PoderColectivos methodsFor: 'as yet unclassified' stamp: ''!
energiaColectivaMinima: unaCantidad 
	energiaColectivaMinima := unaCantidad! !

!PoderColectivos methodsFor: 'as yet unclassified' stamp: ''!
minimoAliadosVivos
	^ minimoAliadosVivos! !

!PoderColectivos methodsFor: 'as yet unclassified' stamp: ''!
minimoAliadosVivos: unaCantidad 
	minimoAliadosVivos := unaCantidad! !

!PoderColectivos methodsFor: 'as yet unclassified' stamp: ''!
puedeHacerlo: unGuerrero 
	^ unGuerrero energia > 200 & (self minimoAliadosVivos > 4) ! !

!PoderColectivos methodsFor: 'as yet unclassified' stamp: ''!
puntosAtaque: unGuerrero 
	^ unGuerrero aliados size + energiaColectivaMinima + 200! !

Object subclass: #PoderLiviano
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DBZ tp'!

!PoderLiviano methodsFor: 'as yet unclassified' stamp: ''!
energiaNecesaria
	^ 50! !

!PoderLiviano methodsFor: 'as yet unclassified' stamp: ''!
puedeHacerlo: unGuerrero 
	^ unGuerrero energia > 50 ! !

Object subclass: #PoderPotente
	instanceVariableNames: 'potenciaAtaque'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DBZ tp'!

!PoderPotente methodsFor: 'as yet unclassified' stamp: ''!
puedeHacerlo
	^ true ! !

!PoderPotente methodsFor: 'as yet unclassified' stamp: ''!
puntosAtaque: unGuerrero 
	unGuerrero nivelPelea / 500 * potenciaAtaque ! !

Object subclass: #PoderVengativo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DBZ tp'!

Object subclass: #SemillaHermitanio
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DBZ tp'!

Object subclass: #TrajeComun
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DBZ tp'!

!TrajeComun methodsFor: 'as yet unclassified' stamp: ''!
efecto: unGuerrero 
	^ 0.1! !

Object subclass: #TrajeEntrenamiento
	instanceVariableNames: 'calculoAtaquesRecibidos ataquesRecibidosA ataquesRecibidos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DBZ tp'!

!TrajeEntrenamiento methodsFor: 'as yet unclassified' stamp: ''!
efecto: unGuerrero 
	unGuerrero calculoAtaquesRecibidos > 0
		ifTrue: [unGuerrero nivelPelea: unGuerrero nivelPelea + (100 * unGuerrero calculoAtaquesRecibidos).
			unGuerrero energia: unGuerrero energia - 20]
		ifFalse: [unGuerrero energia: unGuerrero energia - 20].
	^ unGuerrero recibeAtaque! !

Object subclass: #TrajeEspecial
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DBZ tp'!

!TrajeEspecial methodsFor: 'as yet unclassified' stamp: ''!
efecto: unGuerrero 
	^ unGuerrero recibeAtaque * 0.1 - 20! !
